import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class ViewAndEditCart extends HttpServlet {
    
  public void doGet (HttpServletRequest request,
                     HttpServletResponse response)
      throws ServletException, IOException {

    doPost(request,response);
  }

  public void doPost (HttpServletRequest request,
                     HttpServletResponse response)
      throws ServletException, IOException {

	response.setContentType("text/html");
	PrintWriter out = response.getWriter();

    String cno[] = request.getParameterValues("customerId");	
    String uAccess[] = request.getParameterValues("uAccess");	

	try {
	  Class.forName("oracle.jdbc.driver.OracleDriver");
    } catch(ClassNotFoundException e){
	    out.println("Error loading the Driver:"+e.getMessage()); 
        return;
	  }
	
	Connection conn = null;
	
	try {
	  conn = DriverManager.getConnection (
         MyUtilities.CONNECTSTRING,MyUtilities.ID,MyUtilities.PASSWORD);
	} catch (SQLException e1) {
	    out.println("Error connecting to Oracle:"+e1.getMessage()); 
        return;
	  }
    if (conn == null) {
      out.println("Null Connection");
      return;
    }
	
	Statement stmt = null;
	try {
	  stmt = conn.createStatement ();
	} catch (SQLException e) {
	    out.println("createStatement " + e.getMessage());
        try {conn.close();} catch (SQLException e2) {};
        return;
	  }
	
	ResultSet rset = null;
	
    String query0 = "select u_access from customers where cno='"+ cno[0]+"'";
	try {
	    rset = stmt.executeQuery(query0);
	} catch (SQLException e) {
	    out.println("executeQuery " + e.getMessage());
        return;
      }
      try {
        if (!(rset.next())) {
          out.println("1You are not authorized to access this page");
          return;
        }
        else if (!(uAccess[0].equals(rset.getString(1)))) {
          out.println("2You are not authorized to access this page");
          return;
        }
        else { // everything is fine
          String sTrack = "select 1440*(sysdate-l_access) from customers where cno='" + cno[0] + "'";
          rset = stmt.executeQuery(sTrack);
          rset.next();
          if (rset.getDouble(1) > 10.0) {
                      out.println("<html>");
            out.println("  <head>");
            out.println("    <title>Logout Page</title>");
            out.println("  </head>");
            out.println("  <body>");

            int nRows = stmt.executeUpdate("update customers set u_access = null where cno='" + cno[0] + "'");
            out.println("Your session has expired!<BR> Please Login again to continue shopping.");
            out.println("</center>");
            out.println("</body>");
            out.println("</html>");
            return;
         }
                               
         int nRows = stmt.executeUpdate("update customers set l_access = sysdate where cno='" + cno[0] + "'"); 

        String query1 = "select cartno from cart where cno='" + cno[0] + "'";
        try {
          rset = stmt.executeQuery(query1);
        } catch (SQLException e) {
            out.println("executeQuery " + e.getMessage());
            return;
          }
        if ( !(rset.next()) ) {
          out.println("<html>");
          out.println("  <head>");
          out.println("    <title>ModifyCart</title>");
          out.println("  </head>");
          out.println("  <body>"); 
          out.println("Your Cart is currently Empty");
          out.println("</body>");
          out.println("</html>");
          return;
        }

        String query2 = "select c.pno, p.pname, c.qty, p.price, c.qty*p.price from cart c, parts p where c.cno='" + cno[0] + "' and c.pno = p.pno";  
        try {
          rset = stmt.executeQuery(query2);
        } catch (SQLException e) {
            out.println("executeQuery " + e.getMessage());
            return;
          }
        double sum = 0.0d;
        out.println("<html>");
        out.println("  <head>");
        out.println("    <title>ModifyCart</title>");
        out.println("  </head>");
        out.println("  <body>"); 
        out.println("<center>");
        out.println("<B>Cart Contents</B><BR><BR>");
        out.println("<form method=\"POST\" action=\""+
           MyUtilities.URLPREFIX + "ModifyCart\">"); 
        out.println("<input type = \"hidden\" name=\"customerId\" value=\"" + cno[0] + "\">");
        out.println("<input type = \"hidden\" name=\"uAccess\" value=\"" + uAccess[0] + "\">");
        out.println("<table border=2>");
        out.println("<tr>");
        out.println("<th>PNO</th>");
        out.println("<th>PNAME</th>");
        out.println("<th>PRICE</th>");
        out.println("<th>QTY</th>");
        out.println("<th>COST</th>");
        out.println("</tr>");
        while (rset.next()) {
          out.println("<tr>");
          out.println("<td>" + rset.getString(1) + "</td>");
          out.println("<td>" + rset.getString(2) + "</td>");
          out.println("<td align=\"right\">" + rset.getString(4) + "</td>");
          out.println("<td><input type=\"text\" name=\"" + rset.getString(1) + "\" size=3 maxlength=10 value=\"" + rset.getInt(3) + "\"></td>"); 
          out.println("<td align=\"right\">" + rset.getString(5) + "</td>");
          sum += Double.valueOf(rset.getString(5)).doubleValue();
          out.println("</tr>");
        }
        out.println("<tr>");
        out.println("<td align=\"right\" colspan=4>Total Cost:</td>");
        out.println("<td align=\"right\">" + sum + "</td>");
        out.println("</tr>");
        out.println("</table><BR><BR>");
        out.println("<input type=\"submit\" value=\"Modify Cart\">"); 
        out.println("</form>");
        out.println("<BR><BR>If you are done shopping, click CheckOut");
        out.println("</center>");
        out.println("</body>");
        out.println("</html>");
      }
    } catch (SQLException e) {
        out.println("executeQuery " + e.getMessage());
        return;
      }

	
    try {
      stmt.close();
      conn.close();	
    } catch (SQLException e) {
        out.println("executeQuery " + e.getMessage());
        return;
      }
    
    out.close();
  }
    
    
  public String getServletInfo() {
    return "This Servlet processes View And Edit Cart";
  }
}

